## clblast 1.5.2

=== CMakeLists.txt ===

# ==================================================================================================
# This file is part of the CLBlast project. The project is licensed under Apache Version 2.0. This
# project loosely follows the Google C++ styleguide and uses a tab-size of two spaces and a max-
# width of 100 characters per line.
#
# Author(s):
#   Cedric Nugteren <www.cedricnugteren.nl>
#
# ==================================================================================================

cmake_minimum_required(VERSION 2.8.11)

# Overrides for MSVC static runtime
option(OVERRIDE_MSVC_FLAGS_TO_MT "Override compiler flags for MSVC to build with a static runtime (/MT instead of /MD)" ON)
if(OVERRIDE_MSVC_FLAGS_TO_MT)
  set(CMAKE_USER_MAKE_RULES_OVERRIDE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/c_flag_overrides.cmake)
  set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_flag_overrides.cmake)
endif()

# CMake project details
project("clblast" C CXX)
set(clblast_VERSION_MAJOR 1)
set(clblast_VERSION_MINOR 5)
set(clblast_VERSION_PATCH 2)
set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
set(clblast_SOVERSION ${clblast_VERSION_MAJOR})

# Options and their default values
option(BUILD_SHARED_LIBS "Build a shared (ON) or static library (OFF)" ON)
option(SAMPLES "Enable compilation of the examples" OFF)
option(TUNERS "Enable compilation of the tuners" ON)
option(CLIENTS "Enable compilation of the clients to test and compare performance" OFF)
option(TESTS "Enable compilation of the correctness tests" OFF)
option(CUBLAS "Enables performance comparison against cuBLAS on NVIDIA GPUs" OFF)

# The optional Netlib API for CLBlast
option(NETLIB "Enable compilation of the CBLAS Netlib API" OFF)
option(NETLIB_PERSISTENT_OPENCL "Makes OpenCL device and context in the CBLAS Netlib API static" OFF)
if(NETLIB)
  message("-- Building the Netlib API of CLBlast")
  if(NETLIB_PERSISTENT_OPENCL)
    message("   ^^ while using static variables for OpenCL device and context")
    add_definitions(-DNETLIB_PERSISTENT_OPENCL)
  endif()
endif()

# Workarounds for bugs
option(AMD_SI_EMPTY_KERNEL_WORKAROUND "Enables workaround for bug in AMD Southern Island GPUs" OFF)
if(AMD_SI_EMPTY_KERNEL_WORKAROUND)
  add_definitions(-DAMD_SI_EMPTY_KERNEL_WORKAROUND)
endif()

# Select between an OpenCL API (default) or a CUDA API (beta)
option(OPENCL "Build CLBlast with an OpenCL API (default)" ON)
option(CUDA "Build CLBlast with a CUDA API (beta)" OFF)
if(NOT OPENCL AND NOT CUDA)
  message(FATAL_ERROR "No API selected, choose from OpenCL (-DOPENCL=ON) or CUDA (-DCUDA=ON)")
endif()
if(OPENCL AND CUDA)
  message(FATAL_ERROR "Multiple APIs selected, choose either OpenCL (-DOPENCL=ON -DCUDA=OFF) or CUDA (-DCUDA=ON -DOPENCL=OFF)")
endif()
if(OPENCL)
  message("-- Building CLBlast with OpenCL API (default)")
  add_definitions(-DOPENCL_API)
elseif(CUDA)
  message("-- Building CLBlast with CUDA API (beta)")
  add_definitions(-DCUDA_API)
endif()

# Compile in verbose mode with additional diagnostic messages
option(VERBOSE "Compile in verbose mode for additional diagnostic messages" OFF)
if(VERBOSE)
  message("-- Building in verbose mode")
  add_definitions(-DVERBOSE)
endif()

# ==================================================================================================

# RPATH settings
set(CMAKE_MACOSX_RPATH 1)

# ==================================================================================================

# Compiler-version check (requires at least CMake 2.8.10)
if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
    message(FATAL_ERROR "GCC version must be at least 4.7")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL Clang)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.3)
    message(FATAL_ERROR "Clang version must be at least 3.3")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL AppleClang)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
    message(FATAL_ERROR "AppleClang version must be at least 5.0")
  endif()
elseif(CMAKE_CXX_COMPILER_ID STREQUAL Intel)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 14.0)
    message(FATAL_ERROR "ICC version must be at least 14.0")
  endif()
elseif(MSVC)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 18.0)
    message(FATAL_ERROR "MS Visual Studio version must be at least 18.0")
  endif()
endif()

# DLL Settings
if(MSVC)
  if(BUILD_SHARED_LIBS)
    add_definitions(" /DCLBLAST_DLL")
  endif()
endif(MSVC)

# C++ compiler settings
if(MSVC)
  set(FLAGS "/Ot")
  set(FLAGS "${FLAGS} /wd4715 /D_CRT_SECURE_NO_WARNINGS")
else()
  set(FLAGS "-std=c++11")
  if(VERBOSE)
    set(FLAGS "${FLAGS} -O1 -g")
  else()
    set(FLAGS "${FLAGS} -O2")
  endif()
  if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    set(FLAGS "${FLAGS} -Wall -Wno-comment -Wno-return-type -Wno-switch -Wno-missing-noreturn")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9.0)
      set(FLAGS "${FLAGS} -Wno-attributes -Wno-unused-variable")
    endif()
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.0.0)
      # GCC does not support attributes on template arguments
      # in particular we hit this with the alignment attributes on cl_XXX types
      # which are then used to instantiate various templates in CLBlast
      set(FLAGS "${FLAGS} -Wno-ignored-attributes")
    endif()
  elseif(CMAKE_CXX_COMPILER_ID MATCHES Clang)
    set(FLAGS "${FLAGS} -Wextra -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-padded")
    set(FLAGS "${FLAGS} -Wno-missing-prototypes -Wno-float-equal -Wno-switch-enum -Wno-switch")
    set(FLAGS "${FLAGS} -Wno-exit-time-destructors -Wno-global-constructors -Wno-missing-noreturn")
    set(FLAGS "${FLAGS} -Wno-deprecated-declarations")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.9.0)  # clang 4.0 or higher
        if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0.0)  # but not for AppleClang
          set(FLAGS "${FLAGS} -Wno-undefined-var-template")
        endif()
    endif()
  endif()
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}")

# C compiler settings (for the sample)
if(MSVC)
  set(CFLAGS "/Ot")
else()
  set(CFLAGS "-O2 -std=c99")
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CFLAGS}")

# ==================================================================================================

# Package scripts location
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${clblast_SOURCE_DIR}/cmake/Modules/")

if(OPENCL)
  # Requires OpenCL. It is found through the included "FindOpenCL.cmake" in CMAKE_MODULE_PATH.
  find_package(OpenCL REQUIRED)
  set(API_LIBRARIES ${OPENCL_LIBRARIES})
  set(API_INCLUDE_DIRS ${OPENCL_INCLUDE_DIRS})
elseif(CUDA)
  # For CUDA, the "FindCUDA.cmake" is part of CMake
  find_package(CUDA REQUIRED)
  set(API_LIBRARIES cuda nvrtc)
  set(API_INCLUDE_DIRS ${CUDA_INCLUDE_DIRS})
  link_directories(${CUDA_TOOLKIT_ROOT_DIR}/lib64)
endif()

# Don't search for system libraries when cross-compiling
if(${CMAKE_SYSTEM_NAME} STREQUAL Android)
  if(TESTS)
    message(STATUS "Compilation of the tests disabled for the Android target")
    set(TESTS OFF)
  endif()
  if(CLIENTS)
    message(STATUS "Head-to-head performance comparison not supported in the clients for the Android target")
  endif()
else()

  # Locates the reference BLAS libraries in case the tests need to be compiled. The "FindclBLAS.cmake",
  # "FindCBLAS.cmake", "FindMKL.cmake", and "FindcuBLAS.cmake" are included.
  if(CLIENTS OR TESTS)
    find_package(CBLAS)
    find_package(MKL)
    if(OPENCL)
      find_package(clBLAS)
    endif()
    if(CUBLAS)
      find_package(cuBLAS)
    endif()
    if(NOT CLBLAS_FOUND AND NOT CBLAS_FOUND AND NOT MKL_FOUND)
      if(TESTS)
        message(STATUS "Could NOT find clBLAS nor a CPU BLAS, disabling the compilation of the tests")
        set(TESTS OFF)
      endif()
      if(CLIENTS)
        message(STATUS "Could NOT find clBLAS nor a CPU BLAS, head-to-head performance comparison not supported in the clients")
      endif()
    endif()
  endif()
endif()

# ==================================================================================================

# Sets the supported routines and the used kernels. New routines and kernels should be added here.
set(KERNELS copy_fast copy_pad transpose_fast transpose_pad xaxpy xdot xger
            xgemm xgemm_direct xgemv invert xconvgemm)
set(DATABASES copy pad padtranspose transpose xaxpy xdot
              xgemm xgemm_direct xgemv xgemv_fast xgemv_fast_rot xger invert
              gemm_routine trsv_routine xconvgemm)
set(ROUTINE_TUNERS xgemm xtrsv)
set(LEVEL1_ROUTINES xswap xscal xcopy xaxpy xdot xdotu xdotc xnrm2 xasum xamax)
set(LEVEL2_ROUTINES xgemv xgbmv xhemv xhbmv xhpmv xsymv xsbmv xspmv xtrmv xtbmv xtpmv xtrsv
                    xger xgeru xgerc xher xhpr xher2 xhpr2 xsyr xspr xsyr2 xspr2)
set(LEVEL3_ROUTINES xgemm xsymm xhemm xsyrk xherk xsyr2k xher2k xtrmm xtrsm)
set(LEVELX_ROUTINES xhad xomatcopy xim2col xcol2im xconvgemm xaxpybatched xgemmbatched xgemmstridedbatched)
set(ROUTINES ${LEVEL1_ROUTINES} ${LEVEL2_ROUTINES} ${LEVEL3_ROUTINES} ${LEVELX_ROUTINES})
set(PRECISIONS 32 64 3232 6464 16)

# Sample programs
if(OPENCL)
  set(SAMPLE_PROGRAMS_CPP sgemm sgemm_batched dtrsm tuning_api)
  set(SAMPLE_PROGRAMS_C sasum samax dgemv sgemm haxpy cache)
  if(NETLIB)
    set(SAMPLE_PROGRAMS_C ${SAMPLE_PROGRAMS_C} sgemm_netlib)
  endif()
elseif(CUDA)
  set(SAMPLE_PROGRAMS_CPP daxpy_cuda sgemm_cuda)
  set(SAMPLE_PROGRAMS_C )
endif()

# ==================================================================================================

# Gathers all source-files (required for the compiler) and header-files (for IDEs only)
set(SOURCES
  src/database/database.cpp
  src/routines/common.cpp
  src/utilities/compile.cpp
  src/utilities/clblast_exceptions.cpp
  src/utilities/timing.cpp
  src/utilities/utilities.cpp
  src/api_common.cpp
  src/cache.cpp
  src/kernel_preprocessor.cpp
  src/routine.cpp
  src/routines/levelx/xinvert.cpp  # only source, don't include it as a test
  src/tuning/configurations.cpp
)
set(HEADERS  # such that they can be discovered by IDEs such as CLion and Visual Studio
  include/clblast_half.h
  src/database/apple_cpu_fallback.hpp
  src/database/database.hpp
  src/database/database_structure.hpp
  src/routines/level1/xamin.hpp
  src/routines/level1/xmax.hpp
  src/routines/level1/xmin.hpp
  src/routines/level1/xsum.hpp
  src/routines/common.hpp
  src/routines/routines.hpp
  src/utilities/buffer_test.hpp
  src/utilities/compile.hpp
  src/utilities/clblast_exceptions.hpp
  src/utilities/device_mapping.hpp
  src/utilities/msvc.hpp
  src/utilities/timing.hpp
  src/utilities/utilities.hpp
  src/cache.hpp
  src/kernel_preprocessor.hpp
  src/cxpp11_common.hpp
  src/routine.hpp
  src/tuning/configurations.hpp
  src/tuning/tuning.hpp
  src/tuning/routines/routine_tuner.hpp
)
if(OPENCL)
  set(SOURCES ${SOURCES} src/clblast.cpp src/clblast_c.cpp src/tuning/tuning_api.cpp)
  set(HEADERS ${HEADERS} include/clblast.h include/clblast_c.h src/clpp11.hpp)
  if(NETLIB)
    set(SOURCES ${SOURCES} src/clblast_netlib_c.cpp)
    set(HEADERS ${HEADERS} include/clblast_netlib_c.h)
  endif()
elseif(CUDA)
  set(SOURCES ${SOURCES} src/clblast_cuda.cpp)
  set(HEADERS ${HEADERS} include/clblast_cuda.h src/cupp11.hpp)
endif()
foreach(ROUTINE ${LEVEL1_ROUTINES})
  set(SOURCES ${SOURCES} src/routines/level1/${ROUTINE}.cpp)
  set(HEADERS ${HEADERS} src/routines/level1/${ROUTINE}.hpp)
endforeach()
foreach(ROUTINE ${LEVEL2_ROUTINES})
  set(SOURCES ${SOURCES} src/routines/level2/${ROUTINE}.cpp)
  set(HEADERS ${HEADERS} src/routines/level2/${ROUTINE}.hpp)
endforeach()
foreach(ROUTINE ${LEVEL3_ROUTINES})
  set(SOURCES ${SOURCES} src/routines/level3/${ROUTINE}.cpp)
  set(HEADERS ${HEADERS} src/routines/level3/${ROUTINE}.hpp)
endforeach()
foreach(ROUTINE ${LEVELX_ROUTINES})
  set(SOURCES ${SOURCES} src/routines/levelx/${ROUTINE}.cpp)
  set(HEADERS ${HEADERS} src/routines/levelx/${ROUTINE}.hpp)
endforeach()
foreach(DATABASE ${DATABASES})

## clblast 1.5.1

=== debian/changelog ===
clblast (1.5.1-2) unstable; urgency=medium

  * Move git repository to Salsa.
  * Add watch file.

 -- Gard Spreemann <gspr@nonempty.org>  Sun, 10 Jan 2021 12:33:04 +0100

clblast (1.5.1-1) unstable; urgency=medium

  * Initial release (Closes: #977907)

 -- Gard Spreemann <gspr@nonempty.org>  Tue, 22 Dec 2020 18:38:01 +0100

=== debian/control ===
Source: clblast
Maintainer: Gard Spreemann <gspr@nonempty.org>
Section: math
Priority: optional
Standards-Version: 4.5.1
Build-Depends: cmake,
               debhelper-compat (= 13),
               libblas-dev,
               ocl-icd-opencl-dev | opencl-dev
Rules-Requires-Root: no
Homepage: https://cnugteren.github.io/clblast/clblast.html
Vcs-Browser: https://salsa.debian.org/gspr/clblast
Vcs-Git: https://salsa.debian.org/gspr/clblast.git -b debian/sid

Package: clblast-tests
Section: math
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tests for CLBlast
 CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
 library written in C++11. It is designed to leverage the full
 performance potential of a wide variety of OpenCL devices from
 different vendors, including desktop and laptop GPUs, embedded GPUs,
 and other accelerators. CLBlast implements BLAS routines: basic
 linear algebra subprograms operating on vectors and matrices.
 .
 This package provides tests and benchmarks against other BLAS
 implementations.

Package: clblast-utils
Section: math
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utilities for CLBlast
 CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
 library written in C++11. It is designed to leverage the full
 performance potential of a wide variety of OpenCL devices from
 different vendors, including desktop and laptop GPUs, embedded GPUs,
 and other accelerators. CLBlast implements BLAS routines: basic
 linear algebra subprograms operating on vectors and matrices.
 .
 This package provides utilities for tuning the implementation for
 specific hardware.

Package: libclblast1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tuned OpenCL BLAS library
 CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
 library written in C++11. It is designed to leverage the full
 performance potential of a wide variety of OpenCL devices from
 different vendors, including desktop and laptop GPUs, embedded GPUs,
 and other accelerators. CLBlast implements BLAS routines: basic
 linear algebra subprograms operating on vectors and matrices.
 .
 This package provides the shared library.

Package: libclblast-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libclblast1 (= ${binary:Version}),
         ocl-icd-opencl-dev | opencl-dev
Suggests: liblbfgsb-doc, liblbfgsb-examples
Description: Tuned OpenCL BLAS library (development files)
 CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
 library written in C++11. It is designed to leverage the full
 performance potential of a wide variety of OpenCL devices from
 different vendors, including desktop and laptop GPUs, embedded GPUs,
 and other accelerators. CLBlast implements BLAS routines: basic
 linear algebra subprograms operating on vectors and matrices.
 .
 This package provides the static library and headers.

## clblast 1.5.2

=== debian/changelog ===
clblast (1.5.2-2) unstable; urgency=medium

  * Add patch to correct typo in installation path of CMake
    files. (Closes: #987881)

 -- Gard Spreemann <gspr@nonempty.org>  Sat, 01 May 2021 13:55:46 +0200

clblast (1.5.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop erroneous suggests caused by typo.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 20 Jan 2021 15:44:39 +0100

=== debian/control ===
--- 
+++ 
@@ -64,7 +64,6 @@
 Depends: ${misc:Depends},
          libclblast1 (= ${binary:Version}),
          ocl-icd-opencl-dev | opencl-dev
-Suggests: liblbfgsb-doc, liblbfgsb-examples
 Description: Tuned OpenCL BLAS library (development files)
  CLBlast is a modern, lightweight, performant and tunable OpenCL BLAS
  library written in C++11. It is designed to leverage the full

## clblast 1.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 5)
-set(clblast_VERSION_PATCH 2)
+set(clblast_VERSION_PATCH 3)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})

=== debian/changelog ===
clblast (1.5.3-2) unstable; urgency=medium

  * Restrict autopkgtests to a limited set of architectures (precision
    problems on others).
  * Discover autopkgtests at run-time.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 13 Oct 2022 16:47:47 +0200

clblast (1.5.3-1) unstable; urgency=medium

  * New upstream release.
  * Drop upstreamed patch.
  * Standards-version 4.6.1.1. No changes needed.
  * Add autopkgtests.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 12 Oct 2022 20:07:27 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Gard Spreemann <gspr@nonempty.org>
 Section: math
 Priority: optional
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1.1
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libblas-dev,

## clblast 1.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,10 +21,13 @@
 # CMake project details
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
-set(clblast_VERSION_MINOR 5)
-set(clblast_VERSION_PATCH 3)
+set(clblast_VERSION_MINOR 6)
+set(clblast_VERSION_PATCH 0)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})
+
+# Policies
+cmake_policy(SET CMP0074 NEW)  # to make -DCBLAS_ROOT= work with newer CMake versions as well
 
 # Options and their default values
 option(BUILD_SHARED_LIBS "Build a shared (ON) or static library (OFF)" ON)
@@ -124,7 +127,7 @@
     set(FLAGS "${FLAGS} -O2")
   endif()
   if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
-    set(FLAGS "${FLAGS} -Wall -Wno-comment -Wno-return-type -Wno-switch -Wno-missing-noreturn")
+    set(FLAGS "${FLAGS} -Wall -Wno-comment -Wno-return-type -Wno-switch -Wno-missing-noreturn -Wno-unused-function")
     if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9.0)
       set(FLAGS "${FLAGS} -Wno-attributes -Wno-unused-variable")
     endif()
@@ -138,7 +141,7 @@
     set(FLAGS "${FLAGS} -Wextra -Wno-c++98-compat -Wno-c++98-compat-pedantic -Wno-padded")
     set(FLAGS "${FLAGS} -Wno-missing-prototypes -Wno-float-equal -Wno-switch-enum -Wno-switch")
     set(FLAGS "${FLAGS} -Wno-exit-time-destructors -Wno-global-constructors -Wno-missing-noreturn")
-    set(FLAGS "${FLAGS} -Wno-deprecated-declarations")
+    set(FLAGS "${FLAGS} -Wno-deprecated-declarations -Wno-unused-function")
     if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.9.0)  # clang 4.0 or higher
         if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0.0)  # but not for AppleClang
           set(FLAGS "${FLAGS} -Wno-undefined-var-template")
@@ -304,7 +307,3 @@
   set(HEADERS ${HEADERS} src/routines/level3/${ROUTINE}.hpp)
 endforeach()
 foreach(ROUTINE ${LEVELX_ROUTINES})
-  set(SOURCES ${SOURCES} src/routines/levelx/${ROUTINE}.cpp)
-  set(HEADERS ${HEADERS} src/routines/levelx/${ROUTINE}.hpp)
-endforeach()
-foreach(DATABASE ${DATABASES})

=== debian/changelog ===
clblast (1.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 08 Jun 2023 11:54:29 +0200

clblast (1.5.3-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields.

  [ Gard Spreemann ]
  * Standards-version 4.6.2.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 26 Jan 2023 16:45:33 +0100

## clblast 1.6.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 6)
-set(clblast_VERSION_PATCH 0)
+set(clblast_VERSION_PATCH 1)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})

=== debian/changelog ===
clblast (1.6.1-1) unstable; urgency=medium

  * New upstream release.

 -- Gard Spreemann <gspr@nonempty.org>  Wed, 12 Jul 2023 11:51:54 +0200

## clblast 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 6)
-set(clblast_VERSION_PATCH 1)
+set(clblast_VERSION_PATCH 2)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})

=== debian/changelog ===
clblast (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Add patch to remain compatible with -Werror=format-security.

 -- Gard Spreemann <gspr@nonempty.org>  Sat, 10 Feb 2024 14:12:38 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Gard Spreemann <gspr@nonempty.org>
 Section: math
 Priority: optional
-Standards-Version: 4.6.1.1
+Standards-Version: 4.6.2.0
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libblas-dev,

## clblast 1.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,12 +22,14 @@
 project("clblast" C CXX)
 set(clblast_VERSION_MAJOR 1)
 set(clblast_VERSION_MINOR 6)
-set(clblast_VERSION_PATCH 2)
+set(clblast_VERSION_PATCH 3)
 set(clblast_VERSION "${clblast_VERSION_MAJOR}.${clblast_VERSION_MINOR}.${clblast_VERSION_PATCH}")
 set(clblast_SOVERSION ${clblast_VERSION_MAJOR})
 
 # Policies
-cmake_policy(SET CMP0074 NEW)  # to make -DCBLAS_ROOT= work with newer CMake versions as well
+IF(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
+  cmake_policy(SET CMP0074 NEW)  # to make -DCBLAS_ROOT= work with newer CMake versions as well
+ENDIF(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
 
 # Options and their default values
 option(BUILD_SHARED_LIBS "Build a shared (ON) or static library (OFF)" ON)
@@ -304,6 +306,3 @@
 endforeach()
 foreach(ROUTINE ${LEVEL3_ROUTINES})
   set(SOURCES ${SOURCES} src/routines/level3/${ROUTINE}.cpp)
-  set(HEADERS ${HEADERS} src/routines/level3/${ROUTINE}.hpp)
-endforeach()
-foreach(ROUTINE ${LEVELX_ROUTINES})

=== src/pyclblast/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)
project(${SKBUILD_PROJECT_NAME} LANGUAGES CXX)

# Find python and numpy
find_package(
  Python3
  REQUIRED
  COMPONENTS Interpreter Development.Module NumPy
)

# Run the cython compiler
cmake_path(APPEND CMAKE_CURRENT_SOURCE_DIR "./src"
  OUTPUT_VARIABLE Cython_SOURCE_DIR)
find_program(CYTHON "cython")
add_custom_command(
  OUTPUT "${Cython_SOURCE_DIR}/pyclblast.cpp"
  DEPENDS "${Cython_SOURCE_DIR}/pyclblast.pyx"
  VERBATIM
  COMMAND "${CYTHON}" -3 "${Cython_SOURCE_DIR}/pyclblast.pyx"
          --output-file "${Cython_SOURCE_DIR}/pyclblast.cpp")


# Add module target
Python3_add_library(pyclblast MODULE WITH_SOABI
                    "${Cython_SOURCE_DIR}/pyclblast.cpp")

# Numpy libraries - NOTE: clean NPY_LIBRARIES cache (may fail for venv)
cmake_path(GET Python3_NumPy_INCLUDE_DIRS PARENT_PATH Python3_NumPy_CORE_DIR)
unset(NPY_LIBRARIES CACHE)
find_library(NPY_LIBRARIES
  NAMES npymath
  PATHS ${Python3_NumPy_CORE_DIR}
  PATH_SUFFIXES lib
  DOC "Numpy math library"
  REQUIRED
  NO_DEFAULT_PATH)
target_link_libraries(pyclblast PRIVATE ${NPY_LIBRARIES})
target_include_directories(pyclblast PRIVATE ${Python3_NumPy_INCLUDE_DIRS})

# CLBlast library
set(CLBLAST_HINTS
  ${CLBLAST_ROOT}
  $ENV{CLBLAST_ROOT}
)
find_package(CLBlast CONFIG REQUIRED HINTS ${CLBLAST_HINTS})
target_link_libraries(pyclblast PRIVATE clblast)

install(TARGETS pyclblast DESTINATION .)

# In windows pyclblast cannot find the dll, even on path.
# Probably related to change in 3.8, that loads dll only for trusted location
# see https://stackoverflow.com/questions/41365446/how-to-resolve-importerror-dll-load-failed-on-python
# One workaround is to copy the dll to the same dir as the module.
# TODO: add python version check
if (WIN32)
  cmake_path(APPEND CLBlast_DIR "../../../bin" OUTPUT_VARIABLE CLBlast_BINDIR)
  cmake_path(SET CLBlast_BINDIR NORMALIZE "${CLBlast_BINDIR}")
  unset(CLBlast_SHARED_LIBPATH CACHE)
  find_file(CLBlast_SHARED_LIBPATH
    NAMES clblast.dll
    PATHS ${CLBlast_BINDIR}
    DOC "CLBlast shared library"
    REQUIRED)

  # copy dll to build
  install(FILES ${CLBlast_SHARED_LIBPATH} DESTINATION .)
endif()

=== debian/changelog ===
clblast (1.6.3-2) unstable; urgency=medium

  * Add patch to support CMake 4. (Closes: #1112786)
  * Standards-version 4.7.2.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Thu, 09 Oct 2025 11:08:43 +0200

clblast (1.6.3-1) unstable; urgency=medium

  * New upstream version.
  * Drop upstreamed patch.
  * Standards-version 4.7.0. No changes needed.

 -- Gard Spreemann <gspr@nonempty.org>  Fri, 14 Jun 2024 07:57:08 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Maintainer: Gard Spreemann <gspr@nonempty.org>
 Section: math
 Priority: optional
-Standards-Version: 4.6.2.0
+Standards-Version: 4.7.2.0
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libblas-dev,

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

FLAGS:=-DCUBLAS=false -DCUDA=false -DNETLIB=false -DOPENCL=true

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-static -- -DBUILD_SHARED_LIBS=false -DTUNERS=false -DTESTS=false $(FLAGS)
	dh_auto_configure --builddirectory=build --        -DBUILD_SHARED_LIBS=true  -DTUNERS=true  -DTESTS=true  $(FLAGS)

override_dh_auto_build:
	dh_auto_build --builddirectory=build-static
	dh_auto_build --builddirectory=build

override_dh_auto_clean:
	dh_auto_clean --builddirectory=build-static
	dh_auto_clean --builddirectory=build

override_dh_auto_install:
	dh_auto_install --builddirectory=build-static
	dh_auto_install --builddirectory=build

override_dh_missing:
	dh_missing --list-missing

=== debian/tests/control ===
Tests: tests-pocl.sh
Depends: clblast-tests, colorized-logs, gcc, ocl-icd-opencl-dev | opencl-dev, pocl-opencl-icd
Architecture: amd64 arm64 i386
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%clblast-$1.tar.gz%" \
     https://github.com/CNugteren/CLBlast/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
